<template>
  <template-page ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
    :operation="operation" :exportList="exportList" :operationColumnWidth="160">
    <el-dialog title="" width="500px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
      :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
      <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
        <zj-form-module :title="formDialogTitles[formDialogType]" label-width="100px" :showPackUp="false"
          :form-data="formData" :form-items="formItems">
        </zj-form-module>
      </zj-form-container>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="formCancel">取 消</el-button>
        <el-button size="mini" @click="formConfirm" type="primary">确 定</el-button>
      </div>
    </el-dialog>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import {
  goodsNewsCategoryListPageV2,
  goodsNewsCategoryPageExport,
  addNewclassify,
  getNewclassifyDetail,
  editNewclassifyDetail,
  changeNewclassify,
  deleteNewclassify
} from "@/api/goods";
export default {
  components: { TemplatePage },
  mixins: [import_mixin],
  data() {
    return {
      // 事件组合
      optionsEvensGroup: [
        [
          [
            {
              name: '新建',
              isRole: true,
              click: this.addData
            }
          ],
        ],
      ],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑"],
      formDialog: false,
      formData: {
        mainTitle: '',
        subTitle: '',
        type: '',
        sortNum: '',
      },
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '主标题',
          prop: 'mainTitle',
          rules: [...required]
        }
      }, {
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '副标题',
          prop: 'subTitle',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'el-radio',
        options: [
          { label: "普通商品", value: 1 },
          { label: "套购商品", value: 2 },
        ],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formData.flag === 'START' || this.formDialogType == 2 },
        formItemAttributes: {
          label: '商品类别',
          prop: 'type',
          rules: [...required]
        }
      }, {
        md: 24,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '排序',
          prop: 'sortNum',
          rules: []
        }
      }]
    }
  },
  methods: {
    // 列表请求函数
    getList: goodsNewsCategoryListPageV2,
    // 列表导出函数
    exportList: goodsNewsCategoryPageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 表格操作列
    operation(h, { row, index, column }) {
      return (
        <div class='operation-btns'>
          <el-button type="text" onClick={() => {
            this.$router.push({
              name: "newclassify_set",
              query: {
                item: row
              },
            });
          }}>配置</el-button>
          <el-button type="text" onClick={() => {
            getNewclassifyDetail({ newsCategoryId: row.goodsNewsCategoryId }).then(res => {
              Object.assign(this.formData, res.data)
              this.formDialogType = 1
              this.openForm()
            })
          }}>编辑</el-button>
          <el-popconfirm
            title={`是否确定${row.status ? "关闭" : "开启"}？`}
            onConfirm={() => {
              changeNewclassify({
                goodsNewsCategoryId: row.goodsNewsCategoryId,
                status: row.status,
              }).then(res => {
                this.$message({ type: 'success', message: `${row.status ? "关闭" : "开启"}成功!` })
                this.$refs.pageRef.refreshList()
              })
            }}
          >
            <el-button type="text" slot="reference">{row.status ? "关闭" : "开启"}</el-button>
          </el-popconfirm>
          <el-popconfirm
            title="确定删除吗？"
            onConfirm={() => {
              deleteNewclassify({ goodsNewsCategoryId: row.goodsNewsCategoryId }).then(() => {
                this.$message({ type: 'success', message: '删除成功!' })
                this.$refs.pageRef.refreshList()
              })
            }}
          >
            <el-button type="text" slot="reference">删除</el-button>
          </el-popconfirm>
        </div>
      )
    },
    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      this.formDialog = true;
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ([addNewclassify, editNewclassifyDetail][this.formDialogType])(this.formData).then(res => {
            this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
